package com.gts.annotations.processor;

import java.util.Set;

import javax.annotation.processing.AbstractProcessor;
import javax.annotation.processing.Filer;
import javax.annotation.processing.Messager;
import javax.annotation.processing.ProcessingEnvironment;
import javax.annotation.processing.RoundEnvironment;
import javax.annotation.processing.SupportedAnnotationTypes;
import javax.annotation.processing.SupportedSourceVersion;
import javax.lang.model.SourceVersion;
import javax.lang.model.element.TypeElement;
import javax.tools.Diagnostic.Kind;

@SupportedAnnotationTypes( { "com.gts.annotations.ATest" })
@SupportedSourceVersion(SourceVersion.RELEASE_6)
public class ATestProcessor extends AbstractProcessor {

	private ProcessingEnvironment _processingEnv;
	private Messager _messager;
	private Filer _filer;
	
	@Override
	public boolean process(Set<? extends TypeElement> elements,
			RoundEnvironment env) {
		for (TypeElement element : elements) {
			log(Kind.NOTE, element.getQualifiedName().toString());
		}
		log(Kind.NOTE, "All done now.");
		return true;
	}
	
	@Override
	public synchronized void init(ProcessingEnvironment processingEnv) {
		super.init(processingEnv);
		_processingEnv = processingEnv;
		_filer = _processingEnv.getFiler();
		_messager = _processingEnv.getMessager();
	}
	
	private void log(Kind level, String msg){
		_messager.printMessage(level,msg);
	}
}
